apiVersion: apps/v1
kind: Deployment
metadata:
  namespace: {{ .Release.Namespace }}
  name: portal-tomcat-deployment
spec:
  selector:
    matchLabels:
      app: portal-tomcat
  template:
    metadata:
      labels:
        app: portal-tomcat
      annotations:
        checksum/config1: {{ include (print $.Template.BasePath "/keycloak-configmap.yaml") . | sha256sum }}
        checksum/config2: {{ include (print $.Template.BasePath "/portal-configmap.yaml") . | sha256sum }}
    spec:
      initContainers:
        - name: wait-for-keycloak
          image: sequenceiq/busybox
          args:
          - /bin/sh
          - -c
          - >
            set -x;
            while [ $(curl -skw '%{http_code}' "http://keycloak-service.{{ .Values.sharedEnvironment }}.svc.cluster.local:8080/auth/realms/master" -o /dev/null) -ne 200 ]; do
              sleep 15;
            done
        - name: init-keycloak-config
          image: adorsys/keycloak-config-cli:v4.0.1-14.0.0
          imagePullPolicy: IfNotPresent
          env:
            - name: KEYCLOAK_PASSWORD
              value: admin
            - name: KEYCLOAK_URL
              value: http://keycloak-service.{{ .Values.sharedEnvironment }}.svc.cluster.local:8080/auth
            - name: KEYCLOAK_AVAILABILITYCHECK_ENABLED
              value: "false"
            - name: KEYCLOAK_AVAILABILITYCHECK_TIMEOUT
              value: "10s"
            - name: IMPORT_FORCE
              value: "false"
          volumeMounts:
            - name: config-volume-keycloak
              mountPath: /config/keycloak-config.json
              subPath: keycloak-config.json
      containers:
        - image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: Always
          name: portal-tomcat
          env:
            - name: JAVA_TOOL_OPTIONS
              value: "-agentlib:jdwp=transport=dt_socket,address=5000,server=y,suspend=n"
          ports:
            - containerPort: 5000
              name: "jvm-debug"
            - containerPort: 8080
          volumeMounts:
          - name: config-volume
            mountPath: /configPortal/backendConfig.json
            subPath: backendConfig.json
          - name: config-volume
            mountPath: /configPortal/moduleConfig.json
            subPath: moduleConfig.json
      volumes:
        - name: config-volume
          configMap:
            name: portal-config
        - name: config-volume-keycloak
          configMap:
            name: keycloak-config
---
apiVersion: v1
kind: Service
metadata:
  namespace: {{ .Release.Namespace }}
  name: portal-service
spec:
  selector:
    app: portal-tomcat
  ports:
    - protocol: TCP
      port: 80
      targetPort: 8080